unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    SaveAs1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Void1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function PerCent (n,s:integer):real;
begin
 PerCent:=(n*100)/s;
end;

function LATCharacter (c:char):boolean;
begin
 LATCharacter:=false;
 if (c>#64) and (c<#91) or (c>#96) and (c<#123)then LATCharacter:=true;
end;

function DOSCharacter (c:char):boolean;
begin
 DOSCharacter:=false;
 if (c>#127) and (c<#160) or (c>#159) and (c<#176) or
  (c>#223) and (c<#240) or (c=#240) or (c=#241) then DOSCharacter:=true;
end;

function WINCharacter (c:char):boolean;
begin
 WINCharacter:=false;
 if (c>#191) or (c=#184) or (c=#168)then WINCharacter:=true;
end;

procedure TForm1.Open1Click(Sender: TObject);
var f:TextFile;
    fb:file of Byte;
    s: String;
    i,n,RealSize,Size,DosCounter,WinCounter,LatCounter: Integer;
begin
 if OpenDialog1.Execute then begin
  assignfile(f,OpenDialog1.FileName);
  {$I-}
  reset(f);
  {I+}
  if IOResult=0 then begin
   Memo1.Visible:=True;
   Memo1.Lines.Clear;
   Memo1.Lines.Add(' '+OpenDialog1.FileName);
   Size:=0; n:=0; DosCounter:=0; WinCounter:=0; LatCounter:=0;
   while not Eof (f) do begin
    Readln (f,s);
    if n<10 then begin
     Memo1.Lines.Add(s);
     Inc(n);
     If n=10 Then Memo1.Lines.Add('...');
    end;
    Inc (Size,Length(s));
    For i:=1 To Length(s) do begin
     If LatCharacter(s[i]) then Inc (LatCounter)
     else begin
      If DOSCharacter(s[i]) then Inc(DosCounter);
      If WINCharacter(s[i]) then Inc(WinCounter);
     end;
    end;
   end;
   CloseFile (f);
   assignfile(fb,OpenDialog1.FileName);
   reset(fb);
   RealSize:=FileSize(fb);
   CloseFile (fb);
   Memo1.Lines.Add(' :'+IntToStr(RealSize)+' ');
   Memo1.Lines.Add(' :'+IntToStr(Size)+' ');
   If (PerCent(LatCounter+DosCounter+WinCounter,Size)<60) or
    (PerCent(Size,RealSize)<33) Then begin
    Memo1.Lines.Add ('!   ,    ');
    SaveAs1.Enabled:=False;
   end
   Else begin
    s:=' : ';
    If DosCounter > WinCounter then S:=S+' DOS'
    else S:=S+' Windows';
    Memo1.Lines.Add(s);
    SaveAs1.Enabled:=True;
   End;
  end;
 end;
end;

procedure Recode (var s:string);
var i,c:integer;
begin
 for i:=0 to length (s) do begin
  c:= Ord (s[i]);
  if (c>127) and (c<160) or (c>159) and (c<176) then c:=c+64
  else if (c>223) and (c<240) then c:=c+16
  else if c=240 then c:=168
  else if c=241 then c:=184
  else if c>127 then c:=32;
  s[i]:=Chr (c);
 end;
end;

function Dividor (c:char):boolean;
begin
 Dividor:=false;
 if (c=' ') or (c=#9) or (c=#10) or (c=#13) then Dividor:=true;
end;

function Compress (var s,p:string;var js:integer;var LastSp:boolean):integer;
label 10;
var i,ret,j,spaces:integer;
    DashBefore:boolean;
begin
 i:=1; j:=1; p:=''; spaces:=0; DashBefore:=false;
 LastSp:=true;
 while Dividor(s[i])=true do i:=i+1;
 ret:=i;
 if ret=length (s) then Compress:=-1
 else begin
  for i:=ret to length (s) do begin
   if (Dividor(s[i])=true) then begin
    if spaces=0 then begin
     spaces:=1; p:=p+s[i]; j:=j+1;
    end;
   end
   else begin
    if (s[i]='-') then begin
     if (i=length (s)) then LastSp:=false;
     if (DashBefore=true) or (i=length (s)) then begin
      DashBefore:=false;
      continue;
     end
     else begin
      DashBefore:=true;
      goto 10;
     end;
    end
    else begin
10:
     spaces:=0;
     p:=p+s[i]; j:=j+1;
    end;
   end;
  end;
  p:=p+#0; js:=j-1;
  Compress:=ret;
 end;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
const DefaultExt: array [1..2] of string=('.htm','.txt');
var f1,f2:TextFile;
    s,p: String;
    i,ns,js:integer;
    LastSp:boolean;
begin
 if SaveDialog1.Execute then begin
  s:=SaveDialog1.FileName;
  p:=ExtractFileExt (s);
  if p<>DefaultExt[SaveDialog1.FilterIndex] then
   s:=ChangeFileExt (s,DefaultExt[SaveDialog1.FilterIndex]);
  assignfile(f1,OpenDialog1.FileName);
  reset(f1);
  assignfile(f2,s);
  {$I-}
  rewrite(f2);
  {I+}
  if IOResult=0 then begin
   if SaveDialog1.FilterIndex=1 then begin
    writeln (f2,'<!-- Generated by txt2html.exe -->');
    writeln (f2,'<html><head><title></title></head><body bgcolor=white text=black>');
   end;
   Memo1.Lines.Clear;
   Memo1.Lines.Add (' '+s+' ...');
   while not Eof (f1) do begin
    ReadLn (f1,s);
    If Length (s)=0 Then ns:=-1
    else begin
     Recode (s);
     if SaveDialog1.FilterIndex=2 then begin
      WriteLn (f2,s);
      continue;
     end;
     ns:=Compress (s,p,js,LastSp);
    end;
    if ns=-1 then writeln (f2,'<p>') {   }
    else begin
     if ns>1 then writeln (f2,'<p>');
     for i:=1 to js do write (f2,p[i]);
     if (LastSp=true) then write (f2,' ');
    end;
   end;
   if SaveDialog1.FilterIndex=1 then 
    writeln (f2,'</body></html>');
   Memo1.Lines.Add ('');
  end;
  CloseFile (f2);
  CloseFile (f1);
 end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 with Memo1 do begin
  Visible:=True;
  Lines.Clear;
  Lines.Add (
   '     DOS  Windows'+#13+#10+
   '  TXT  HTML.'+#13+#10+
   '""     ,'+#13+#10+
   '      .'+#13+#10+
   '-----------------------------------------------------'+#13+#10+
   ' freeware,      2 .'+#13+#10+
   '      ,   '+#13+#10+
   ' Source.'+#13+#10+
   '   Delphi :-)'+#13+#10+
   ', pers@mail.ru');
 end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

end.
